clear all
close all

rng(0);

dataset=6;
switch dataset
 case 1 % dependent (regression)
  n=100;
  X=(rand(1,n)*2-1)*10;
  Y=sin(X/10*pi);
  axis_list=[-10.2 10.2 -1.2 1.2];
  y_type=0; % regression
 case 2 % independent (regression)
  n=100;
  X=(rand(1,n)*2-1)*10;
  Y=(rand(1,n)*2-1);
  axis_list=[-10.2 10.2 -1.2 1.2];
  y_type=0; % regression
 case 3 % dependent (regression)
  n=100;
  Z=bsxfun(@plus,randn(2,n),(rand(1,n)>.5)*2-1);
  X=Z(1,:);
  Y=Z(2,:);
  axis_list=[-4.5 4.5 -4.5 4.5];
  y_type=0; % regression
 case 4 % independent (regression)
  n=100;
  Z=rand(2,n)*2-1;
  X=Z(1,:);
  Y=Z(2,:);
  axis_list=[-1.2 1.2 -1.2 1.2];
  y_type=0; % regression
 case 5 % dependent (classification)
  n=100;
  X=[randn(1,n/2)-5 randn(1,n/2)+5];
  Y=[-ones(1,n/2) ones(1,n/2)];
  axis_list=[-10 10 -1.2 1.2];
  y_type=1; % classification
 case 6 % independent (classification)
  n=100;
  X=[randn(1,n/2)-5 randn(1,n/2)+5];
  Y=sign(randn(1,n));
  axis_list=[-10 10 -1.2 1.2];
  y_type=1; % classification
end

SMIh=mLSMI(X,Y,y_type);

fprintf('dataset: %d\n',dataset);
fprintf('(Estimated SMI between x and y) = %g\n',SMIh);

%%%%%%%%%%%%%%%%%%%%%% Displaying original 2D data
figure(dataset)
clf
hold on

set(gca,'FontName','Helvetica')
set(gca,'FontSize',12)
plot(X,Y,'ro','LineWidth',1,'MarkerSize',8);
xlabel('x')
ylabel('y')
axis(axis_list)
title(sprintf('(Estimated SMI between x and y) = %g',SMIh))

set(gcf,'PaperUnits','centimeters');
set(gcf,'PaperPosition',[0 0 12 9]);
print('-depsc',sprintf('mLSMI-%g',dataset))